
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Fan_profilesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const fan_profiles = await db.fan_profiles.create(
            {
                id: data.id || undefined,
        
        nickname: data.nickname
        ||
        null
            ,
            
        bio: data.bio
        ||
        null
            ,
            
        hide_social_activity: data.hide_social_activity
        ||
        false
        
            ,
            
        xp_coins_balance: data.xp_coins_balance
        ||
        null
            ,
            
        adult_mode_enabled: data.adult_mode_enabled
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await fan_profiles.setUser( data.user || null, {
            transaction,
        });
        
        await fan_profiles.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return fan_profiles;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const fan_profilesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                nickname: item.nickname
            ||
            null
            ,
            
                bio: item.bio
            ||
            null
            ,
            
                hide_social_activity: item.hide_social_activity
            ||
            false
        
            ,
            
                xp_coins_balance: item.xp_coins_balance
            ||
            null
            ,
            
                adult_mode_enabled: item.adult_mode_enabled
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const fan_profiles = await db.fan_profiles.bulkCreate(fan_profilesData, { transaction });

        // For each item created, replace relation files
        

        return fan_profiles;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const fan_profiles = await db.fan_profiles.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.nickname !== undefined) updatePayload.nickname = data.nickname;
        
        
        if (data.bio !== undefined) updatePayload.bio = data.bio;
        
        
        if (data.hide_social_activity !== undefined) updatePayload.hide_social_activity = data.hide_social_activity;
        
        
        if (data.xp_coins_balance !== undefined) updatePayload.xp_coins_balance = data.xp_coins_balance;
        
        
        if (data.adult_mode_enabled !== undefined) updatePayload.adult_mode_enabled = data.adult_mode_enabled;
        
        
        updatePayload.updatedById = currentUser.id;

        await fan_profiles.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await fan_profiles.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await fan_profiles.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return fan_profiles;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const fan_profiles = await db.fan_profiles.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of fan_profiles) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of fan_profiles) {
                await record.destroy({transaction});
            }
        });


        return fan_profiles;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const fan_profiles = await db.fan_profiles.findByPk(id, options);

        await fan_profiles.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await fan_profiles.destroy({
            transaction
        });

        return fan_profiles;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const fan_profiles = await db.fan_profiles.findOne(
            { where },
            { transaction },
        );

        if (!fan_profiles) {
            return fan_profiles;
        }

        const output = fan_profiles.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await fan_profiles.getUser({
            transaction
        });
        
        
        output.organizations = await fan_profiles.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.nickname) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'fan_profiles',
                        'nickname',
                        filter.nickname,
                    ),
                };
            }
            
            if (filter.bio) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'fan_profiles',
                        'bio',
                        filter.bio,
                    ),
                };
            }
            

            
            

            
            if (filter.xp_coins_balanceRange) {
                const [start, end] = filter.xp_coins_balanceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    xp_coins_balance: {
                    ...where.xp_coins_balance,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    xp_coins_balance: {
                    ...where.xp_coins_balance,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.hide_social_activity) {
                where = {
                    ...where,
                hide_social_activity: filter.hide_social_activity,
            };
            }
            
            if (filter.adult_mode_enabled) {
                where = {
                    ...where,
                adult_mode_enabled: filter.adult_mode_enabled,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.fan_profiles.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'fan_profiles',
                        'nickname',
                        query,
                    ),
                ],
            };
        }

        const records = await db.fan_profiles.findAll({
            attributes: [ 'id', 'nickname' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['nickname', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.nickname,
        }));
    }

    
};

